// Terminal version for 1.8" TFT modul by ADAFRUIT 
// ( ST7735 driver ); Pgm is based based on article by 
// N3BAH, "D-Terminal: ARDUINO meets D-STAR"
// from QST April 2014 p.30-32
// Pgm modified by DJ7OO ( dj7oo@t-online.de )

#define sclk 13
#define mosi 11
#define cs   10
#define dc   9
#define rst  8  

#include <Adafruit_GFX.h>    
#include <Adafruit_ST7735.h> 
#include <SPI.h>
#include <PS2Keyboard.h>

#define IRQ_PIN 3 
#define DATA_PIN 4                          

Adafruit_ST7735 tft = Adafruit_ST7735(cs, dc, rst);

int ledPin = 5;
int inPin = 2;
PS2Keyboard keyboard;
char myArray[128];
long baud;
char incomingByte;
int x;

/////////////////////////////////////////////////////////////////////
void setup(void) {

  pinMode(ledPin, OUTPUT); // output LED, light if message available
  pinMode(inPin, INPUT); // input pin, when pressed display message
  digitalWrite(inPin,HIGH);    //pull-up #2 "ON"  
  digitalWrite(0,HIGH);        //pull-up #0 "ON"  
  keyboard.begin(DATA_PIN, IRQ_PIN); //dataPin, IRQpin

  Serial.begin(9600); 
  Serial.println("Start");

  tft.initR(INITR_BLACKTAB);   
  tft.setRotation(tft.getRotation() + 1); // rotate 90degs
  tft.setTextSize(3);    
  tft.fillScreen(ST7735_BLACK);
  tft.setTextColor(ST7735_YELLOW); 
  tft.setCursor(42,15);
  tft.print("MINI");
  tft.setCursor(8,45);
  tft.print("TERMINAL"), 
  tft.setTextSize(2);    
  tft.setCursor(28,105);
  tft.print("V1.1 2014"), 
  delay(5000);
  tft.fillScreen(ST7735_BLACK);
  tft.setCursor(0, 0);
}

/////////////////////////////////////////////////////////////////////////////////
void loop() {
  KeyData();
  if (Serial.available() > 0) {  
    digitalWrite(ledPin, HIGH);
  if (digitalRead(inPin) == 0) {
  tft.setTextWrap(true);
  tft.write(Serial.read());
  }
  digitalWrite(ledPin, LOW); // LED off because no message remains
 }
}
  
/////////////////////////////////////////////////////////////
void KeyData() {
//get keyboard input
  if(keyboard.available() > 0) {
    int dat = keyboard.read();
    int val = dat - '0';
//PRINT INPUT TO LCD
    if(dat == PS2_ENTER) {
Serial.print(dat);  
    SendData();
Serial.write(13);
Serial.write(10);

    } 
    else if(dat == PS2_ESC) {
  tft.fillScreen(ST7735_BLACK);
  tft.setCursor(0, 0);
      x=0;      
    } 
    else if(dat !=  PS2_ENTER && dat != PS2_ESC) {
//scrolls LCD display of keyboard input
    myArray[x]=dat;  
    x++;
    tft.setTextWrap(true);
    tft.write(dat);
    } 
  }   
}

/////////////////////////////////////////////////////////////
void SendData() {
  for(int y=0; y<x; y++) {
Serial.print(myArray[y]);
  }  
  tft.setCursor(0, 0);
  tft.fillScreen(ST7735_BLACK);
  x=0;
Serial.flush(); //to prevent the data backwash to LCD after data is sent
  delay(200);
  tft.setCursor(0, 0);
  tft.fillScreen(ST7735_BLACK);
 }
